<?php
namespace Zeedhi\Framework\Util;

/**
 * Class Crypt
 *
 * Class used for encrypt and decrypt data through salt's
 *
 * @package Zeedhi\Framework\Util
 */
class Crypt {


    /**
     * @param $salt
     * @return string
     */
    protected function padSalt($salt) {
        //Only keys of sizes 16, 24 or 32 supported.
        //http://php.net/manual/pt_BR/function.mcrypt-encrypt.php See changelog.
        $salt = str_pad($salt, 32, '\0');
        return $salt;
    }

    /**
     * Encrypt data with salt.
     *
     * @param string $text Value to be encrypt.
     * @param string $salt Salt to be encrypt.
     *
     * @return string
     */
    public function encrypt($text, $salt = 'zeedhi')
    {
        return trim(
            base64_encode(
                mcrypt_encrypt(
                    MCRYPT_RIJNDAEL_256,
                    $this->padSalt($salt),
                    $text,
                    MCRYPT_MODE_ECB,
                    mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB), MCRYPT_RAND)
                )
            )
        );
    }


    /**
     * Decrypt data through salt.
     *
     * @param string $text Value to be decrypt.
     * @param string $salt Salt used in encryption.
     *
     * @return string
     */
    public function decrypt($text, $salt = 'zeedhi')
    {
        return trim(
            mcrypt_decrypt(
                MCRYPT_RIJNDAEL_256,
                $this->padSalt($salt),
                base64_decode($text),
                MCRYPT_MODE_ECB,
                mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB), MCRYPT_RAND)
            )
        );
    }
} 