var ZeedhiFields = angular.module("ZeedhiFields");

ZeedhiFields.directive('zhInlineEditable', function($timeout, templateManager, maskEngine, ZhUtil) {
	return {
		link: function($scope, elem, attrs) {
			var column = $scope.$eval(attrs.zhInlineEditable);
			if (column && column.inlineEditable) {
				$timeout(function() {
					var elementContainer = elem.parent("div").parent("div");
					elementContainer.addClass('inline-editable');

					elementContainer.on('click.editable', function(e) {
						$scope.widget.inlineEditing = true;
						$scope.widget.lastInlineEditingElement = elementContainer;

						var input = elem;

						if (!input[0]._initialized) {
							input.on('blur', function(e) {
								var currentRow = $scope.widget.currentRow;

								var rowValue;
								var inputValue;
								if (column.mask) {
									rowValue = currentRow[column.name];
									inputValue = currentRow[column.name + "_inline"];
								} else {
									//Use the old behaviour for users that rely on the zhInlineEditable: "number" behaviour
									rowValue = getParsedValue(currentRow[column.name], column);
									inputValue = getParsedValue(input.val(), column);
								}

								if (rowValue != inputValue) {
									// put the widget in editing mode only if there is something changed
									$scope.widget.inlineEdit();
									templateManager.updateTemplate();

									if (Util.isUndefined(currentRow['changed_' + column.name])) {
										currentRow['changed_' + column.name] = currentRow[column.name];
									}

									if (!column.mask && isNumber(column)) {
										currentRow[column.name + "_inline"] = (isNaN(inputValue) || !inputValue) ? undefined : parseFloat(inputValue);
									}

									currentRow.changed = true;
									currentRow[column.name] = currentRow[column.name + "_inline"];
									$scope.row[column.name] = currentRow[column.name + "_inline"];

									$timeout(function() {
										$(window).trigger('resize.grid', $scope.widget.id);
									});
								} else if (!$scope.widget.inInlineEditMode()) {
									$scope.widget.inlineEditing = false;
								}

								var evtData = {
									data: {
										field: column
									}
								};
								if (column._isLastInlineEditable && $scope.widget.beforeInlineEditMoveRow) {
									$scope.widget.beforeInlineEditMoveRow($scope.widget.currentRow);
								}
								if (column.onInlineEdit) {
									column.onInlineEdit(evtData);
								}
								input.css('display', 'none');
							});

							input[0]._initialized = true;
						}

						if ($scope.widget.currentRow != $scope.row) {
							$scope.widget.setCurrentRow($scope.row);
						}

						if ($scope.widget.currentRow[column.name + "_inline"]) {
							input.val($scope.widget.currentRow[column.name + "_inline"]);
						} else {
							$scope.widget.currentRow[column.name + "_inline"] = $scope.widget.currentRow[column.name];
							$scope.row[column.name + "_inline"] = $scope.widget.currentRow[column.name];
							var val = $scope.widget.currentRow[column.name];
							input.val(val);
						}

						input.css('display', 'block');

						horizontalScrollToColumn(input);
						Util.selectElement(input);

						templateManager.updateTemplate();

						e.stopPropagation();
					});

					$(window).on('resize.grid.after', function(event) {
						if ($scope.widget.inlineEditing) {
							horizontalScrollToColumn($scope.widget.lastInlineEditingElement);
						}
					});
				});
			}

			function getClosestParentWithScroll(inputElement) {
				return inputElement.closest('.nonbounce').parent().parent().find('.body-scroll-control');
			}

			function horizontalScrollToColumn(inputElement) {
				var closestHorizontalScroller = getClosestParentWithScroll(inputElement);
				var elementPosition = closestHorizontalScroller.scrollLeft() + inputElement.offset().left;
				closestHorizontalScroller.scrollLeft(elementPosition - 20);
			}

			function isNumber(column) {
				return column.inlineEditable === 'number';
			}

			function getParsedValue(value, column) {
				return (value && isNumber(column)) ? value.toString().replace(",", ".") : value;
			}
		}
	};
});